package xyz.veronie.bgg.ui.contributions;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;

/// These are the controls to retrieve IDs for a given BGG user
/// Filters can be set for the state of the thing in the user's collection
/// (i.e. owned, previously owned, wishlist, etc.)
public class SourceFilterBggUser extends Composite {

	public SourceFilterBggUser(final Composite parent, int style) {
		super(parent, style);
		
        Group gFilters = new Group(parent, SWT.SHADOW_ETCHED_IN);
        gFilters.setText("");
        
        GridData gdFilters = new GridData(SWT.FILL, SWT.FILL, true, true);
        gFilters.setLayoutData(gdFilters);
        
        GridLayout filterLayout = new GridLayout(4, false);
        gFilters.setLayout(filterLayout);
        
        Label lblUser = new Label(gFilters, SWT.LEFT);
        lblUser.setText("User name: ");
        lblUser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		        
        Combo cbUserName = new Combo(gFilters, SWT.DROP_DOWN);
        cbUserName.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
        
        Button btEditUsers = new Button(gFilters, SWT.PUSH);
        btEditUsers.setText("edit users");
        btEditUsers.setEnabled(false);
        btEditUsers.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
        // TODO: implement edit users



        Label infoLabel = new Label(gFilters, SWT.LEFT);
        infoLabel.setText("Select which flags are used as filter. Filters follow 'AND' rule.");
        GridData gdInfo = new GridData(SWT.FILL, SWT.FILL, true, false);
        gdInfo.horizontalSpan = 4;
        infoLabel.setLayoutData(gdInfo);

        makeFilter(gFilters, "owned", 1);
        makeFilter(gFilters, "want to play", 2);
        
        makeFilter(gFilters, "previously owned", 2);
        makeFilter(gFilters, "want to buy", 2);
        
        makeFilter(gFilters, "for trade", 0);
        makeFilter(gFilters, "wishlist", 2);
        
        makeFilter(gFilters, "wanted", 2);
        makeFilter(gFilters, "preordered", 2);
        
        this.requestLayout();
	}
	
	
	/// Create a control for a filter. 
	// Filters are tristate: include iff has flag, include iff it does not have the flag, 
	// don't care if it has that flag.
	// TODO: create a three-way toggle button instead. 
	private void makeFilter(Composite parent, String filterName, int defaultIdx) {
		Combo filterCombo = new Combo(parent, SWT.READ_ONLY);
		filterCombo.add("ignored");
		filterCombo.add("is");
		filterCombo.add("is not");
		filterCombo.select(defaultIdx);
		filterCombo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		
		Label filterLabel = new Label(parent, SWT.LEFT);
		filterLabel.setText(filterName);
		filterLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
	}
	
	public String toString() {
		return "from BGG user";
	}
}
